/*-
  getpass: prompt user and retrieve a string with no echo to tty
*/

#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <sys/dev.h>

char           *
getpass(char *prompt)
{
	static char     pw[32];
	unsigned        mode;
	int             tty, i;
	char            c;

	if ((tty = open("/dev/tty", O_RDWR)) < 0)
		return 0;
	write(tty, prompt, strlen(prompt));
	mode = dev_mode(tty, 0, _DEV_ECHO);
	for (i = 0; read(tty, &c, sizeof c) > 0 && c != '\n';)
		if (i < sizeof pw)
			pw[i++] = c;
	pw[i] = 0;
	dev_mode(tty, mode, _DEV_ECHO);
	c = '\n';
	write(tty, &c, sizeof c);
	close(tty);
	return pw;
}
